package com.utopiaindustries.hseobservationsapp.activities.PermitToWorkForms;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.google.android.material.textfield.TextInputLayout;
import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.activities.ObservationForms.ObservationThreeActivity;
import com.utopiaindustries.hseobservationsapp.activities.ObservationForms.ObservationTwoActivity;
import com.utopiaindustries.hseobservationsapp.adapters.BuildingsAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.FloorsAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.HsePtwTypeAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.WorkingTeamAdapter;
import com.utopiaindustries.hseobservationsapp.helper.Helper;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseActivity;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseBuilding;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseFloor;
import com.utopiaindustries.hseobservationsapp.models.HseData.HsePtwType;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseWorkingTeam;
import com.utopiaindustries.hseobservationsapp.utils.StorageManager.StorageManager;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

public class PermitOneActivity extends AppCompatActivity {

    private Button btnNext;
    ImageView imgBack;

    private AutoCompleteTextView locationTextview, subLocationTextView, ptwTypeTextView,
            ptwSubTypeTextView, workingTeamTextView;

    private TextInputLayout ptwTextInputLayout;

    private ArrayList<HseBuilding> locationArrayList_temp = new ArrayList<>();
    private ArrayList<HseBuilding> locationArrayList = new ArrayList<>();
    private BuildingsAdapter buildingAdapter;

    private ArrayList<HseFloor> subLocationArrayList_temp = new ArrayList<>();
    private ArrayList<HseFloor> subLocationArrayList = new ArrayList<>();
    private FloorsAdapter floorsAdapter;

    private ArrayList<HsePtwType> ptwTypeArrayList = new ArrayList<>();
    private HsePtwTypeAdapter ptwTypeAdapter;


    private ArrayList<HseWorkingTeam> workingTeamArrayList = new ArrayList<>();
    private WorkingTeamAdapter workingTeamAdapter;

    String location = "", subLocation = "", ptwType = "", workingTeam = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_permit_one);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayout();

        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (isValidate()) {
                    Intent intent = new Intent(PermitOneActivity.this, PermitTwoActivity.class);
                    startActivity(intent);
                }
            }
        });

        locationTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                location = locationArrayList.get(position).getTitle();
                StorageManager.getInstance().getPermitToWorkModel().get(0).setLocationId(locationArrayList.get(position).getId());
            }
        });

        subLocationTextView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                subLocation = subLocationArrayList.get(position).getTitle();
                StorageManager.getInstance().getPermitToWorkModel().get(0).setSubLocationId(subLocationArrayList.get(position).getId());
            }
        });

        ptwTypeTextView.setOnClickListener(v -> {
            showMultiSelectDialog(ptwTypeArrayList, ptwTypeTextView);
        });

        //ptwTextInputLayout
        ptwTextInputLayout.setEndIconMode(TextInputLayout.END_ICON_CUSTOM);
        ptwTextInputLayout.setEndIconDrawable(R.drawable.ic_arrow_drop_down);
        ptwTextInputLayout.setOnClickListener(v -> {
            showMultiSelectDialog(ptwTypeArrayList, ptwTypeTextView);
        });

        workingTeamTextView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                workingTeam = workingTeamArrayList.get(position).getTitle();
                StorageManager.getInstance().getPermitToWorkModel().get(0).setWorkingTeamId(workingTeamArrayList.get(position).getId());
            }
        });

    }

    private void initializeLayout() {

        btnNext = findViewById(R.id.btn_next);
        imgBack = findViewById(R.id.img_back);

        locationTextview = findViewById(R.id.location_textview);
        subLocationTextView = findViewById(R.id.sub_location_textview);
        ptwTypeTextView = findViewById(R.id.ptw_type_textview);
        ptwTextInputLayout = findViewById(R.id.ptw_type_input);

        ptwTypeTextView.setFocusable(false);
        ptwTypeTextView.setCursorVisible(false);
        ptwTypeTextView.setKeyListener(null); // disables keyboard
        ptwTypeTextView.setClickable(true);

        workingTeamTextView = findViewById(R.id.working_team_textview);

        locationArrayList_temp.addAll(Helper.getList(Helper.hseBuildings, this, HseBuilding.class));

        //Location -- Building
        if (!locationArrayList_temp.isEmpty()) {

            List<HseBuilding> filteredUnitItems = locationArrayList_temp.stream()
                    .filter(item -> Objects.equals(item.getSiteId(), StorageManager.getInstance().getSite_id()))
                    .collect(Collectors.toList());

            locationArrayList.clear();
            locationArrayList.addAll(filteredUnitItems);
            buildingAdapter = new BuildingsAdapter(this, locationArrayList);
            locationTextview.setAdapter(buildingAdapter);
        }

        subLocationArrayList_temp.addAll(Helper.getList(Helper.hseFloors, this, HseFloor.class));

        //Sub Location -- floor
        if (!subLocationArrayList_temp.isEmpty()) {

            List<HseFloor> filteredUnitItems = subLocationArrayList_temp.stream()
                    .filter(item -> Objects.equals(item.getSiteId(), StorageManager.getInstance().getSite_id()))
                    .collect(Collectors.toList());

            subLocationArrayList.clear();
            subLocationArrayList.addAll(filteredUnitItems);
            floorsAdapter = new FloorsAdapter(this, subLocationArrayList);
            subLocationTextView.setAdapter(floorsAdapter);
        }

        ptwTypeArrayList.addAll(Helper.getList(Helper.hsePtwType, this, HsePtwType.class));

        workingTeamArrayList.addAll(Helper.getList(Helper.hseWorkingTeams, this, HseWorkingTeam.class));
        workingTeamAdapter = new WorkingTeamAdapter(this, workingTeamArrayList);
        workingTeamTextView.setAdapter(workingTeamAdapter);

    }

    public boolean isValidate() {
        boolean returnValue = true;
        String message = "";

        /*if (workingTeam.isEmpty()) {
            message = "Please select working type.";
            returnValue = false;
        }*/

        if (ptwType.isEmpty()) {
            message = "Please select ptw Type.";
            returnValue = false;
        }

        if (subLocation.isEmpty()) {
            message = "Please select sub location.";
            returnValue = false;
        }

        if (location.isEmpty()) {
            message = "Please select location.";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(this, message, Toast.LENGTH_SHORT).show();
        }

        return returnValue;
    }

    private void showMultiSelectDialog(List<HsePtwType> ptwList, AutoCompleteTextView textView) {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        View dialogView = LayoutInflater.from(this).inflate(R.layout.dialog_recycler, null);
        builder.setView(dialogView);

        @SuppressLint({"MissingInflatedId", "LocalSuppress"}) RecyclerView recyclerView = dialogView.findViewById(R.id.dialogRecyclerView);
        recyclerView.setLayoutManager(new LinearLayoutManager(this));
        HsePtwTypeAdapter adapter = new HsePtwTypeAdapter(this, ptwList);
        recyclerView.setAdapter(adapter);

        builder.setPositiveButton("OK", (dialog, which) -> {
            List<HsePtwType> selected = adapter.getSelectedItems();
            if (selected.size() != 2) {
                Toast.makeText(this, "Please select exactly 2 items", Toast.LENGTH_SHORT).show();
                return;
            }

            String selectedTitles = selected.get(0).getTitle() + ", " + selected.get(1).getTitle();
            textView.setText(selectedTitles);
            ptwType = selectedTitles;
        });

        builder.setNegativeButton("Cancel", (dialog, which) -> dialog.dismiss());

        AlertDialog dialog = builder.create();
        dialog.show();
    }

}