package com.utopiaindustries.hseobservationsapp.utils.StorageManager;

import com.utopiaindustries.hseobservationsapp.activities.ProgressiveActivityForms.ProgressiveActivity;

import java.util.ArrayList;
import java.util.List;

public class StorageManager {
    private static StorageManager instance;
   // private ArrayList<byte[]> imageListPaper;

    private String observation_date;
    private int userId;
    private int site_id;
    private int supervisorId;
    private String supervisorName;
    private String shift;
    private int recordTypeId;
    private String recordTypeName;

    private List<ObservationModel> observationsModel;
    private List<ReportActivityModel> reportActivityModel;
    private List<ReportActivityModel> progressiveActivityModel;
    private List<PermitToWorkModel> permitToWorkModel;


    private StorageManager() {

    }

    public static StorageManager getInstance() {
        if (instance == null) {
            instance = new StorageManager();
            instance.initialize();
        }
        return instance;
    }

    public void initialize() {
        observationsModel = new ArrayList<>();
        observationsModel.add(new ObservationModel());

        reportActivityModel = new ArrayList<>();
        reportActivityModel.add(new ReportActivityModel());

        progressiveActivityModel = new ArrayList<>();
        progressiveActivityModel.add(new ReportActivityModel());

        permitToWorkModel = new ArrayList<>();
        permitToWorkModel.add(new PermitToWorkModel());
    }

    public String getObservation_date() {
        return observation_date;
    }

    public void setObservation_date(String observation_date) {
        this.observation_date = observation_date;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }

    public int getSite_id() {
        return site_id;
    }

    public void setSite_id(int site_id) {
        this.site_id = site_id;
    }

    public int getSupervisorId() {
        return supervisorId;
    }

    public void setSupervisorId(int supervisorId) {
        this.supervisorId = supervisorId;
    }

    public String getSupervisorName() {
        return supervisorName;
    }

    public void setSupervisorName(String supervisorName) {
        this.supervisorName = supervisorName;
    }

    public String getShift() {
        return shift;
    }

    public void setShift(String shift) {
        this.shift = shift;
    }

    public int getRecordTypeId() {
        return recordTypeId;
    }

    public void setRecordTypeId(int recordTypeId) {
        this.recordTypeId = recordTypeId;
    }

    public String getRecordTypeName() {
        return recordTypeName;
    }

    public void setRecordTypeName(String recordTypeName) {
        this.recordTypeName = recordTypeName;
    }

    public List<ObservationModel> getObservationsModel() {
        return observationsModel;
    }

    public void setObservationsModel(List<ObservationModel> observationsModel) {
        this.observationsModel = observationsModel;
    }

    public List<ReportActivityModel> getReportActivityModel() {
        return reportActivityModel;
    }

    public void setReportActivityModel(List<ReportActivityModel> reportActivityModel) {
        this.reportActivityModel = reportActivityModel;
    }

    public List<ReportActivityModel> getProgressiveActivityModel() {
        return progressiveActivityModel;
    }

    public void setProgressiveActivityModel(List<ReportActivityModel> progressiveActivityModel) {
        this.progressiveActivityModel = progressiveActivityModel;
    }

    public List<PermitToWorkModel> getPermitToWorkModel() {
        return permitToWorkModel;
    }

    public void setPermitToWorkModel(List<PermitToWorkModel> permitToWorkModel) {
        this.permitToWorkModel = permitToWorkModel;
    }

    public void clearAllData() {

        observation_date = null;
        userId = 0;
        site_id = 0;
        supervisorId = 0;
        supervisorName = null;
        shift = null;
        recordTypeId = 0;
        recordTypeName = null;

        observationsModel.clear();
        reportActivityModel.clear();
        progressiveActivityModel.clear();
        permitToWorkModel.clear();
    }
}
